<?php

//////////
///
///   blotter.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['blotter.add']      = array('func'   => 'blotter_add',
                                'perm'   => AL_ADMN,
                                'escape' => true);

$dm['blotter.mod']      = array('func'   => 'blotter_mod',
                                'perm'   => AL_ADMN,
                                'escape' => true);

$dm['blotter.del']      = array('func'   => 'blotter_del',
                                'perm'   => AL_ADMN,
                                'escape' => true);

$dm['blotter.get']      = array('func'   => 'blotter_get',
                                'perm'   => AL_ADMN | AL_TECH | AL_VIEW,
                                'escape' => true);

$dm['blotter.addlog']   = array('func'   => 'blotter_addlog',
                                'perm'   => AL_VIEW,
                                'escape' => true);

$dm['blotter.dellog']   = array('func'   => 'blotter_dellog',
                                'perm'   => AL_VIEW,
                                'escape' => true);

$dm['blotter.getlog']   = array('func'   => 'blotter_getlog',
                                'perm'   => AL_VIEW,
                                'escape' => true);



/***************\
*   FUNCTIONS   *
\***************/

function blotter_add($blotter, $desc, $activity_id)
{
   $em[1062] = array('blotter', 'exists');

   $sql  = "INSERT INTO `blotter` (`blotter`, ";
   $sql .=                        "`desc`, ";
   $sql .=                        "`activity_id`) ";
   $sql .= "VALUES ('$blotter', ";
   $sql .=         "'$desc', ";
   $sql .=         "'$activity_id')";

   $ret = db_query($sql, $em);

   if(!is_success($ret)) {
      return $ret;
   }

   $sql = "SELECT LAST_INSERT_ID() AS `blotter_id`";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   return success((integer)$ret['payload'][0]->blotter_id);
}

function blotter_mod($blotter_id, $blotter, $desc)
{
   $em[1062] = array('blotter', 'exists');

   $sql  = "UPDATE `blotter` ";
   $sql .= "SET `blotter` = '$blotter', ";
   $sql .=     "`desc` = '$desc' ";
   $sql .= "WHERE `blotter_id` = '$blotter_id'";

   return db_query($sql, $em);
}

function blotter_del($blotter_id)
{
   $sql  = "DELETE FROM `blotter` ";
   $sql .= "WHERE `blotter_id` = '$blotter_id'";

   return db_query($sql);
}

function blotter_get($blotter_id)
{
   $sql  = "SELECT `blotter_id`, ";
   $sql .=        "`blotter`, ";
   $sql .=        "`desc`, ";
   $sql .=        "`activity_id` ";
   $sql .= "FROM `blotter` ";
   $sql .= "WHERE 1";
   $sql .= ($blotter_id ? " AND `blotter_id` = '$blotter_id'" : '');
   $sql .= (($_SESSION['authlevel'] & AL_ADMN) ? '' : " AND `activity_id` IN ('".implode("', '", $_SESSION['authactivityid'])."')");

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

function blotter_addlog($blotter_id, $log_id)
{
   $em[1062] = array('blotter', 'alreadyin');
   $em[1452] = array('blotter', 'nosuchblotterlog');

   foreach($log_id as $l) {
      $sql  = "SELECT `activity_id` ";
      $sql .= "FROM `blotter` ";
      $sql .= "JOIN `target` ";
      $sql .= "USING (`activity_id`) ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`target_id`) ";
      $sql .= "JOIN `log` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE `blotter_id` = '$blotter_id' AND ";
      $sql .=       "`log_id` = '$l' AND ";
      $sql .=       "`activity_id` IN ('".implode("', '", $_SESSION['authactivityid'])."')";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      } else if($ret['payload'] === false) {
         return error('blotter', 'nosuchblotterlog');
      }

      $sql  = "INSERT INTO `blotter_log` (`blotter_id`, ";
      $sql .=                            "`log_id`) ";
      $sql .= "VALUES ('$blotter_id', ";
      $sql .=         "'$l')";

      $ret = db_query($sql, $em);

      if(!is_success($ret)) {
         return $ret;
      }
   }

   return success(true);
}

function blotter_dellog($blotter_id, $log_id)
{
   foreach($log_id as $l) {
      $sql  = "SELECT `activity_id` ";
      $sql .= "FROM `blotter` ";
      $sql .= "JOIN `target` ";
      $sql .= "USING (`activity_id`) ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`target_id`) ";
      $sql .= "JOIN `log` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE `blotter_id` = '$blotter_id' AND ";
      $sql .=       "`log_id` = '$l' AND ";
      $sql .=       "`activity_id` IN ('".implode("', '", $_SESSION['authactivityid'])."')";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      } else if($ret['payload'] === false) {
         return error('blotter', 'nosuchblotterlog');
      }

      $sql  = "DELETE FROM `blotter_log` ";
      $sql .= "WHERE `blotter_id` = '$blotter_id' AND ";
      $sql .=       "`log_id` = '$l'";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      }
   }

   return success(true);
}

function blotter_getlog($blotter_id)
{
   $sql  = "SELECT `log_id` ";
   $sql .= "FROM `blotter_log` ";
   $sql .= "JOIN `blotter` ";
   $sql .= "USING (`blotter_id`) ";
   $sql .= "WHERE `blotter_id` = '$blotter_id' AND ";
   $sql .=       "`activity_id` IN ('".implode("', '", $_SESSION['authactivityid'])."')";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   foreach($ret['payload'] as &$r) {
      $r = $r->log_id;
   }
   unset($r);

   return $ret;
}

?>
